import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { AddTagsToOnPremisesInstancesCommandInput, AddTagsToOnPremisesInstancesCommandOutput } from "../commands/AddTagsToOnPremisesInstancesCommand";
import { BatchGetApplicationRevisionsCommandInput, BatchGetApplicationRevisionsCommandOutput } from "../commands/BatchGetApplicationRevisionsCommand";
import { BatchGetApplicationsCommandInput, BatchGetApplicationsCommandOutput } from "../commands/BatchGetApplicationsCommand";
import { BatchGetDeploymentGroupsCommandInput, BatchGetDeploymentGroupsCommandOutput } from "../commands/BatchGetDeploymentGroupsCommand";
import { BatchGetDeploymentInstancesCommandInput, BatchGetDeploymentInstancesCommandOutput } from "../commands/BatchGetDeploymentInstancesCommand";
import { BatchGetDeploymentsCommandInput, BatchGetDeploymentsCommandOutput } from "../commands/BatchGetDeploymentsCommand";
import { BatchGetDeploymentTargetsCommandInput, BatchGetDeploymentTargetsCommandOutput } from "../commands/BatchGetDeploymentTargetsCommand";
import { BatchGetOnPremisesInstancesCommandInput, BatchGetOnPremisesInstancesCommandOutput } from "../commands/BatchGetOnPremisesInstancesCommand";
import { ContinueDeploymentCommandInput, ContinueDeploymentCommandOutput } from "../commands/ContinueDeploymentCommand";
import { CreateApplicationCommandInput, CreateApplicationCommandOutput } from "../commands/CreateApplicationCommand";
import { CreateDeploymentCommandInput, CreateDeploymentCommandOutput } from "../commands/CreateDeploymentCommand";
import { CreateDeploymentConfigCommandInput, CreateDeploymentConfigCommandOutput } from "../commands/CreateDeploymentConfigCommand";
import { CreateDeploymentGroupCommandInput, CreateDeploymentGroupCommandOutput } from "../commands/CreateDeploymentGroupCommand";
import { DeleteApplicationCommandInput, DeleteApplicationCommandOutput } from "../commands/DeleteApplicationCommand";
import { DeleteDeploymentConfigCommandInput, DeleteDeploymentConfigCommandOutput } from "../commands/DeleteDeploymentConfigCommand";
import { DeleteDeploymentGroupCommandInput, DeleteDeploymentGroupCommandOutput } from "../commands/DeleteDeploymentGroupCommand";
import { DeleteGitHubAccountTokenCommandInput, DeleteGitHubAccountTokenCommandOutput } from "../commands/DeleteGitHubAccountTokenCommand";
import { DeleteResourcesByExternalIdCommandInput, DeleteResourcesByExternalIdCommandOutput } from "../commands/DeleteResourcesByExternalIdCommand";
import { DeregisterOnPremisesInstanceCommandInput, DeregisterOnPremisesInstanceCommandOutput } from "../commands/DeregisterOnPremisesInstanceCommand";
import { GetApplicationCommandInput, GetApplicationCommandOutput } from "../commands/GetApplicationCommand";
import { GetApplicationRevisionCommandInput, GetApplicationRevisionCommandOutput } from "../commands/GetApplicationRevisionCommand";
import { GetDeploymentCommandInput, GetDeploymentCommandOutput } from "../commands/GetDeploymentCommand";
import { GetDeploymentConfigCommandInput, GetDeploymentConfigCommandOutput } from "../commands/GetDeploymentConfigCommand";
import { GetDeploymentGroupCommandInput, GetDeploymentGroupCommandOutput } from "../commands/GetDeploymentGroupCommand";
import { GetDeploymentInstanceCommandInput, GetDeploymentInstanceCommandOutput } from "../commands/GetDeploymentInstanceCommand";
import { GetDeploymentTargetCommandInput, GetDeploymentTargetCommandOutput } from "../commands/GetDeploymentTargetCommand";
import { GetOnPremisesInstanceCommandInput, GetOnPremisesInstanceCommandOutput } from "../commands/GetOnPremisesInstanceCommand";
import { ListApplicationRevisionsCommandInput, ListApplicationRevisionsCommandOutput } from "../commands/ListApplicationRevisionsCommand";
import { ListApplicationsCommandInput, ListApplicationsCommandOutput } from "../commands/ListApplicationsCommand";
import { ListDeploymentConfigsCommandInput, ListDeploymentConfigsCommandOutput } from "../commands/ListDeploymentConfigsCommand";
import { ListDeploymentGroupsCommandInput, ListDeploymentGroupsCommandOutput } from "../commands/ListDeploymentGroupsCommand";
import { ListDeploymentInstancesCommandInput, ListDeploymentInstancesCommandOutput } from "../commands/ListDeploymentInstancesCommand";
import { ListDeploymentsCommandInput, ListDeploymentsCommandOutput } from "../commands/ListDeploymentsCommand";
import { ListDeploymentTargetsCommandInput, ListDeploymentTargetsCommandOutput } from "../commands/ListDeploymentTargetsCommand";
import { ListGitHubAccountTokenNamesCommandInput, ListGitHubAccountTokenNamesCommandOutput } from "../commands/ListGitHubAccountTokenNamesCommand";
import { ListOnPremisesInstancesCommandInput, ListOnPremisesInstancesCommandOutput } from "../commands/ListOnPremisesInstancesCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { PutLifecycleEventHookExecutionStatusCommandInput, PutLifecycleEventHookExecutionStatusCommandOutput } from "../commands/PutLifecycleEventHookExecutionStatusCommand";
import { RegisterApplicationRevisionCommandInput, RegisterApplicationRevisionCommandOutput } from "../commands/RegisterApplicationRevisionCommand";
import { RegisterOnPremisesInstanceCommandInput, RegisterOnPremisesInstanceCommandOutput } from "../commands/RegisterOnPremisesInstanceCommand";
import { RemoveTagsFromOnPremisesInstancesCommandInput, RemoveTagsFromOnPremisesInstancesCommandOutput } from "../commands/RemoveTagsFromOnPremisesInstancesCommand";
import { SkipWaitTimeForInstanceTerminationCommandInput, SkipWaitTimeForInstanceTerminationCommandOutput } from "../commands/SkipWaitTimeForInstanceTerminationCommand";
import { StopDeploymentCommandInput, StopDeploymentCommandOutput } from "../commands/StopDeploymentCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateApplicationCommandInput, UpdateApplicationCommandOutput } from "../commands/UpdateApplicationCommand";
import { UpdateDeploymentGroupCommandInput, UpdateDeploymentGroupCommandOutput } from "../commands/UpdateDeploymentGroupCommand";
/**
 * serializeAws_json1_1AddTagsToOnPremisesInstancesCommand
 */
export declare const se_AddTagsToOnPremisesInstancesCommand: (input: AddTagsToOnPremisesInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchGetApplicationRevisionsCommand
 */
export declare const se_BatchGetApplicationRevisionsCommand: (input: BatchGetApplicationRevisionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchGetApplicationsCommand
 */
export declare const se_BatchGetApplicationsCommand: (input: BatchGetApplicationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchGetDeploymentGroupsCommand
 */
export declare const se_BatchGetDeploymentGroupsCommand: (input: BatchGetDeploymentGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchGetDeploymentInstancesCommand
 */
export declare const se_BatchGetDeploymentInstancesCommand: (input: BatchGetDeploymentInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchGetDeploymentsCommand
 */
export declare const se_BatchGetDeploymentsCommand: (input: BatchGetDeploymentsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchGetDeploymentTargetsCommand
 */
export declare const se_BatchGetDeploymentTargetsCommand: (input: BatchGetDeploymentTargetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1BatchGetOnPremisesInstancesCommand
 */
export declare const se_BatchGetOnPremisesInstancesCommand: (input: BatchGetOnPremisesInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ContinueDeploymentCommand
 */
export declare const se_ContinueDeploymentCommand: (input: ContinueDeploymentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateApplicationCommand
 */
export declare const se_CreateApplicationCommand: (input: CreateApplicationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateDeploymentCommand
 */
export declare const se_CreateDeploymentCommand: (input: CreateDeploymentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateDeploymentConfigCommand
 */
export declare const se_CreateDeploymentConfigCommand: (input: CreateDeploymentConfigCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateDeploymentGroupCommand
 */
export declare const se_CreateDeploymentGroupCommand: (input: CreateDeploymentGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteApplicationCommand
 */
export declare const se_DeleteApplicationCommand: (input: DeleteApplicationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteDeploymentConfigCommand
 */
export declare const se_DeleteDeploymentConfigCommand: (input: DeleteDeploymentConfigCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteDeploymentGroupCommand
 */
export declare const se_DeleteDeploymentGroupCommand: (input: DeleteDeploymentGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteGitHubAccountTokenCommand
 */
export declare const se_DeleteGitHubAccountTokenCommand: (input: DeleteGitHubAccountTokenCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteResourcesByExternalIdCommand
 */
export declare const se_DeleteResourcesByExternalIdCommand: (input: DeleteResourcesByExternalIdCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeregisterOnPremisesInstanceCommand
 */
export declare const se_DeregisterOnPremisesInstanceCommand: (input: DeregisterOnPremisesInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetApplicationCommand
 */
export declare const se_GetApplicationCommand: (input: GetApplicationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetApplicationRevisionCommand
 */
export declare const se_GetApplicationRevisionCommand: (input: GetApplicationRevisionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetDeploymentCommand
 */
export declare const se_GetDeploymentCommand: (input: GetDeploymentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetDeploymentConfigCommand
 */
export declare const se_GetDeploymentConfigCommand: (input: GetDeploymentConfigCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetDeploymentGroupCommand
 */
export declare const se_GetDeploymentGroupCommand: (input: GetDeploymentGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetDeploymentInstanceCommand
 */
export declare const se_GetDeploymentInstanceCommand: (input: GetDeploymentInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetDeploymentTargetCommand
 */
export declare const se_GetDeploymentTargetCommand: (input: GetDeploymentTargetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetOnPremisesInstanceCommand
 */
export declare const se_GetOnPremisesInstanceCommand: (input: GetOnPremisesInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListApplicationRevisionsCommand
 */
export declare const se_ListApplicationRevisionsCommand: (input: ListApplicationRevisionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListApplicationsCommand
 */
export declare const se_ListApplicationsCommand: (input: ListApplicationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListDeploymentConfigsCommand
 */
export declare const se_ListDeploymentConfigsCommand: (input: ListDeploymentConfigsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListDeploymentGroupsCommand
 */
export declare const se_ListDeploymentGroupsCommand: (input: ListDeploymentGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListDeploymentInstancesCommand
 */
export declare const se_ListDeploymentInstancesCommand: (input: ListDeploymentInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListDeploymentsCommand
 */
export declare const se_ListDeploymentsCommand: (input: ListDeploymentsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListDeploymentTargetsCommand
 */
export declare const se_ListDeploymentTargetsCommand: (input: ListDeploymentTargetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListGitHubAccountTokenNamesCommand
 */
export declare const se_ListGitHubAccountTokenNamesCommand: (input: ListGitHubAccountTokenNamesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListOnPremisesInstancesCommand
 */
export declare const se_ListOnPremisesInstancesCommand: (input: ListOnPremisesInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutLifecycleEventHookExecutionStatusCommand
 */
export declare const se_PutLifecycleEventHookExecutionStatusCommand: (input: PutLifecycleEventHookExecutionStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1RegisterApplicationRevisionCommand
 */
export declare const se_RegisterApplicationRevisionCommand: (input: RegisterApplicationRevisionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1RegisterOnPremisesInstanceCommand
 */
export declare const se_RegisterOnPremisesInstanceCommand: (input: RegisterOnPremisesInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1RemoveTagsFromOnPremisesInstancesCommand
 */
export declare const se_RemoveTagsFromOnPremisesInstancesCommand: (input: RemoveTagsFromOnPremisesInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1SkipWaitTimeForInstanceTerminationCommand
 */
export declare const se_SkipWaitTimeForInstanceTerminationCommand: (input: SkipWaitTimeForInstanceTerminationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StopDeploymentCommand
 */
export declare const se_StopDeploymentCommand: (input: StopDeploymentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateApplicationCommand
 */
export declare const se_UpdateApplicationCommand: (input: UpdateApplicationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateDeploymentGroupCommand
 */
export declare const se_UpdateDeploymentGroupCommand: (input: UpdateDeploymentGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_json1_1AddTagsToOnPremisesInstancesCommand
 */
export declare const de_AddTagsToOnPremisesInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AddTagsToOnPremisesInstancesCommandOutput>;
/**
 * deserializeAws_json1_1BatchGetApplicationRevisionsCommand
 */
export declare const de_BatchGetApplicationRevisionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetApplicationRevisionsCommandOutput>;
/**
 * deserializeAws_json1_1BatchGetApplicationsCommand
 */
export declare const de_BatchGetApplicationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetApplicationsCommandOutput>;
/**
 * deserializeAws_json1_1BatchGetDeploymentGroupsCommand
 */
export declare const de_BatchGetDeploymentGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetDeploymentGroupsCommandOutput>;
/**
 * deserializeAws_json1_1BatchGetDeploymentInstancesCommand
 */
export declare const de_BatchGetDeploymentInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetDeploymentInstancesCommandOutput>;
/**
 * deserializeAws_json1_1BatchGetDeploymentsCommand
 */
export declare const de_BatchGetDeploymentsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetDeploymentsCommandOutput>;
/**
 * deserializeAws_json1_1BatchGetDeploymentTargetsCommand
 */
export declare const de_BatchGetDeploymentTargetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetDeploymentTargetsCommandOutput>;
/**
 * deserializeAws_json1_1BatchGetOnPremisesInstancesCommand
 */
export declare const de_BatchGetOnPremisesInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetOnPremisesInstancesCommandOutput>;
/**
 * deserializeAws_json1_1ContinueDeploymentCommand
 */
export declare const de_ContinueDeploymentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ContinueDeploymentCommandOutput>;
/**
 * deserializeAws_json1_1CreateApplicationCommand
 */
export declare const de_CreateApplicationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateApplicationCommandOutput>;
/**
 * deserializeAws_json1_1CreateDeploymentCommand
 */
export declare const de_CreateDeploymentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDeploymentCommandOutput>;
/**
 * deserializeAws_json1_1CreateDeploymentConfigCommand
 */
export declare const de_CreateDeploymentConfigCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDeploymentConfigCommandOutput>;
/**
 * deserializeAws_json1_1CreateDeploymentGroupCommand
 */
export declare const de_CreateDeploymentGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDeploymentGroupCommandOutput>;
/**
 * deserializeAws_json1_1DeleteApplicationCommand
 */
export declare const de_DeleteApplicationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteApplicationCommandOutput>;
/**
 * deserializeAws_json1_1DeleteDeploymentConfigCommand
 */
export declare const de_DeleteDeploymentConfigCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDeploymentConfigCommandOutput>;
/**
 * deserializeAws_json1_1DeleteDeploymentGroupCommand
 */
export declare const de_DeleteDeploymentGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDeploymentGroupCommandOutput>;
/**
 * deserializeAws_json1_1DeleteGitHubAccountTokenCommand
 */
export declare const de_DeleteGitHubAccountTokenCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteGitHubAccountTokenCommandOutput>;
/**
 * deserializeAws_json1_1DeleteResourcesByExternalIdCommand
 */
export declare const de_DeleteResourcesByExternalIdCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteResourcesByExternalIdCommandOutput>;
/**
 * deserializeAws_json1_1DeregisterOnPremisesInstanceCommand
 */
export declare const de_DeregisterOnPremisesInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeregisterOnPremisesInstanceCommandOutput>;
/**
 * deserializeAws_json1_1GetApplicationCommand
 */
export declare const de_GetApplicationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetApplicationCommandOutput>;
/**
 * deserializeAws_json1_1GetApplicationRevisionCommand
 */
export declare const de_GetApplicationRevisionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetApplicationRevisionCommandOutput>;
/**
 * deserializeAws_json1_1GetDeploymentCommand
 */
export declare const de_GetDeploymentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDeploymentCommandOutput>;
/**
 * deserializeAws_json1_1GetDeploymentConfigCommand
 */
export declare const de_GetDeploymentConfigCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDeploymentConfigCommandOutput>;
/**
 * deserializeAws_json1_1GetDeploymentGroupCommand
 */
export declare const de_GetDeploymentGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDeploymentGroupCommandOutput>;
/**
 * deserializeAws_json1_1GetDeploymentInstanceCommand
 */
export declare const de_GetDeploymentInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDeploymentInstanceCommandOutput>;
/**
 * deserializeAws_json1_1GetDeploymentTargetCommand
 */
export declare const de_GetDeploymentTargetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDeploymentTargetCommandOutput>;
/**
 * deserializeAws_json1_1GetOnPremisesInstanceCommand
 */
export declare const de_GetOnPremisesInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetOnPremisesInstanceCommandOutput>;
/**
 * deserializeAws_json1_1ListApplicationRevisionsCommand
 */
export declare const de_ListApplicationRevisionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListApplicationRevisionsCommandOutput>;
/**
 * deserializeAws_json1_1ListApplicationsCommand
 */
export declare const de_ListApplicationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListApplicationsCommandOutput>;
/**
 * deserializeAws_json1_1ListDeploymentConfigsCommand
 */
export declare const de_ListDeploymentConfigsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDeploymentConfigsCommandOutput>;
/**
 * deserializeAws_json1_1ListDeploymentGroupsCommand
 */
export declare const de_ListDeploymentGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDeploymentGroupsCommandOutput>;
/**
 * deserializeAws_json1_1ListDeploymentInstancesCommand
 */
export declare const de_ListDeploymentInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDeploymentInstancesCommandOutput>;
/**
 * deserializeAws_json1_1ListDeploymentsCommand
 */
export declare const de_ListDeploymentsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDeploymentsCommandOutput>;
/**
 * deserializeAws_json1_1ListDeploymentTargetsCommand
 */
export declare const de_ListDeploymentTargetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDeploymentTargetsCommandOutput>;
/**
 * deserializeAws_json1_1ListGitHubAccountTokenNamesCommand
 */
export declare const de_ListGitHubAccountTokenNamesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListGitHubAccountTokenNamesCommandOutput>;
/**
 * deserializeAws_json1_1ListOnPremisesInstancesCommand
 */
export declare const de_ListOnPremisesInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListOnPremisesInstancesCommandOutput>;
/**
 * deserializeAws_json1_1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_json1_1PutLifecycleEventHookExecutionStatusCommand
 */
export declare const de_PutLifecycleEventHookExecutionStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutLifecycleEventHookExecutionStatusCommandOutput>;
/**
 * deserializeAws_json1_1RegisterApplicationRevisionCommand
 */
export declare const de_RegisterApplicationRevisionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RegisterApplicationRevisionCommandOutput>;
/**
 * deserializeAws_json1_1RegisterOnPremisesInstanceCommand
 */
export declare const de_RegisterOnPremisesInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RegisterOnPremisesInstanceCommandOutput>;
/**
 * deserializeAws_json1_1RemoveTagsFromOnPremisesInstancesCommand
 */
export declare const de_RemoveTagsFromOnPremisesInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RemoveTagsFromOnPremisesInstancesCommandOutput>;
/**
 * deserializeAws_json1_1SkipWaitTimeForInstanceTerminationCommand
 */
export declare const de_SkipWaitTimeForInstanceTerminationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SkipWaitTimeForInstanceTerminationCommandOutput>;
/**
 * deserializeAws_json1_1StopDeploymentCommand
 */
export declare const de_StopDeploymentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopDeploymentCommandOutput>;
/**
 * deserializeAws_json1_1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UpdateApplicationCommand
 */
export declare const de_UpdateApplicationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateApplicationCommandOutput>;
/**
 * deserializeAws_json1_1UpdateDeploymentGroupCommand
 */
export declare const de_UpdateDeploymentGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateDeploymentGroupCommandOutput>;
